<?php

/**
* @package   s9e\TextFormatter
* @copyright Copyright (c) 2010-2016 The s9e Authors
* @license   http://www.opensource.org/licenses/mit-license.php The MIT License
*/
class s9e_renderer_1eb8e8071b3ff27c447d38f522cad016d25e2e18 extends \s9e\TextFormatter\Renderer
{
	protected $params=array('L_CODE'=>'','L_COLON'=>'','L_IMAGE'=>'','L_SELECT_ALL_CODE'=>'','L_WROTE'=>'','STYLE_ID'=>'','S_VIEWFLASH'=>'','S_VIEWIMG'=>'','S_VIEWSMILIES'=>'','T_SMILIES_PATH'=>'');
	protected static $tagBranches=array('ATTACHMENT'=>0,'B'=>1,'CODE'=>2,'COLOR'=>3,'E'=>4,'EMAIL'=>5,'EMOJI'=>6,'FLASH'=>7,'I'=>8,'IMG'=>9,'LI'=>10,'LINK_TEXT'=>11,'LIST'=>12,'QUOTE'=>13,'SIZE'=>14,'U'=>15,'URL'=>16,'br'=>17,'e'=>18,'i'=>18,'s'=>18,'p'=>19);
	protected static $bt57355554=array('#-O'=>0,'#-o'=>1,'#:-S'=>2,'#:-s'=>3,'$-)'=>4,'%%-'=>5,'%-('=>6,'(%)'=>7,'(*)'=>8,'(-|'=>9,'(~~)'=>10,'**=='=>11,'*-:)'=>12,'/:)'=>13,'8-X'=>14,'8-x'=>15,'8-|'=>16,'8-}'=>17,':!!'=>18,':!:'=>19,':('=>20,':(('=>21,':)'=>22,':))'=>23,':)]'=>24,':-!'=>25,':-"'=>26,':-$'=>27,':-('=>28,':-)'=>29,':-*'=>30,':-?'=>31,':-??'=>32,':-@'=>33,':-B'=>34,':-BD'=>35,':-C'=>36,':-D'=>37,':-H'=>38,':-J'=>39,':-L'=>40,':-O'=>41,':-P'=>42,':-Q'=>43,':-S'=>44,':-SS'=>45,':-T'=>46,':-W'=>47,':-\\'=>48,':-b'=>49,':-bd'=>50,':-c'=>51,':-h'=>52,':-j'=>53,':-l'=>54,':-o'=>55,':-p'=>56,':-q'=>57,':-s'=>58,':-ss'=>59,':-t'=>60,':-w'=>61,':?:'=>62,':AR!'=>63,':D'=>64,':O3'=>65,':P'=>66,':X'=>67,':YMALIEN:'=>68,':YMAPPLAUSE:'=>69,':YMBILLY:'=>70,':YMBRINGITON:'=>71,':YMDAYDREAM:'=>72,':YMDEVIL:'=>73,':YMHIRO:'=>74,':YMHUG:'=>75,':YMPARTY:'=>76,':YMPEACE:'=>77,':YMPRAY:'=>78,':YMSICK:'=>79,':YMSIGH:'=>80,':YMSMUG:'=>81,':ar!'=>82,':arrow:'=>83,':d'=>84,':idea:'=>85,':o3'=>86,':p'=>87,':roll:'=>88,':x'=>89,':ymalien:'=>90,':ymapplause:'=>91,':ymbilly:'=>92,':ymblushing:'=>93,':ymbringiton:'=>94,':ymdaydream:'=>95,':ymdevil:'=>96,':ymhiro:'=>97,':ymhug:'=>98,':ymparty:'=>99,':ympeace:'=>100,':ympray:'=>101,':ymsick:'=>102,':ymsigh:'=>103,':ymsmug:'=>104,':|'=>105,';)'=>106,';))'=>107,';;)'=>108,'=(('=>109,'=))'=>110,'=:)'=>111,'=;'=>112,'=P~'=>113,'=p~'=>114,'@-)'=>115,'@};-'=>116,'B-('=>117,'B-)'=>118,'I-)'=>119,'O:-)'=>120,'X('=>121,'X_X'=>122,'[-('=>123,'[-X'=>124,'[-x'=>125,'\\:D/'=>126,'\\:d/'=>127,'\\M/'=>128,'\\m/'=>129,'^#(^'=>130,'^:)^'=>131,'b-('=>132,'b-)'=>133,'i-)'=>134,'o-+'=>135,'o:-)'=>136,'x('=>137,'x_x'=>138,'~O)'=>139,'~X('=>140,'~o)'=>141,'~x('=>142);
	public function __sleep()
	{
		$props = get_object_vars($this);
		unset($props['out'], $props['proc'], $props['source']);
		return array_keys($props);
	}
	public function renderRichText($xml)
	{
		if (!isset($this->quickRenderingTest) || !preg_match($this->quickRenderingTest, $xml))
			try
			{
				return $this->renderQuick($xml);
			}
			catch (\Exception $e)
			{
			}
		$dom = $this->loadXML($xml);
		$this->out = '';
		$this->at($dom->documentElement);
		return $this->out;
	}
	protected function at(\DOMNode $root)
	{
		if ($root->nodeType === 3)
			$this->out .= htmlspecialchars($root->textContent,0);
		else
			foreach ($root->childNodes as $node)
				if (!isset(self::$tagBranches[$node->nodeName]))
					$this->at($node);
				else
				{
					$tb = self::$tagBranches[$node->nodeName];
					if($tb<10)if($tb<5)if($tb<3)if($tb===0)$this->out.='<div class="inline-attachment"><!-- ia'.htmlspecialchars($node->getAttribute('index'),0).' -->'.htmlspecialchars($node->getAttribute('filename'),0).'<!-- ia'.htmlspecialchars($node->getAttribute('index'),0).' --></div>';elseif($tb===1)if($this->params['STYLE_ID']==2){$this->out.='<strong>';$this->at($node);$this->out.='</strong>';}else{$this->out.='<span style="font-weight: bold">';$this->at($node);$this->out.='</span>';}else{$this->out.='<div class="codebox"><p>'.htmlspecialchars($this->params['L_CODE'].$this->params['L_COLON'],0).' <a href="#" onclick="selectCode(this); return false;">'.htmlspecialchars($this->params['L_SELECT_ALL_CODE'],0).'</a></p><pre><code>';$this->at($node);$this->out.='</code></pre></div>';}elseif($tb===3){$this->out.='<span style="color: '.htmlspecialchars($node->getAttribute('color'),2).'">';$this->at($node);$this->out.='</span>';}elseif(empty($this->params['S_VIEWSMILIES']))$this->out.=htmlspecialchars($node->textContent,0);elseif(isset(self::$bt57355554[$node->textContent])){$n=self::$bt57355554[$node->textContent];$this->out.='<img class="smilies" src="'.htmlspecialchars($this->params['T_SMILIES_PATH'],2);if($n<72)if($n<36)if($n<18)if($n<9)if($n<5)if($n<3)if($n===0)$this->out.='/40.gif" width="24" height="18" alt="#-O" title="D oh">';elseif($n===1)$this->out.='/40.gif" width="24" height="18" alt="#-o" title="D oh">';else$this->out.='/18.gif" width="34" height="18" alt="#:-S" title="Whew!">';elseif($n===3)$this->out.='/18.gif" width="34" height="18" alt="#:-s" title="Whew!">';else$this->out.='/64.gif" width="18" height="18" alt="$-)" title="Money eyes">';elseif($n===5)$this->out.='/54.gif" width="18" height="18" alt="%%-" title="Clover">';elseif($n===6)$this->out.='/107.gif" width="52" height="18" alt="%-(" title="Not listening">';elseif($n===7)$this->out.='/75.gif" width="18" height="18" alt="(%)" title="Yin Yang">';else$this->out.='/79.gif" width="18" height="18" alt="(*)" title="Star">';elseif($n<14)if($n<12)if($n===9)$this->out.='/37.gif" width="18" height="18" alt="(-|" title="Yawn">';elseif($n===10)$this->out.='/56.gif" width="17" height="18" alt="(~~)" title="Pumpkin">';else$this->out.='/55.gif" width="25" height="18" alt="**==" title="US Flag">';elseif($n===12)$this->out.='/58.gif" width="30" height="18" alt="*-:)" title="Idea">';else$this->out.='/23.gif" width="18" height="18" alt="/:)" title="Raised eyebrows">';elseif($n===14)$this->out.='/59.gif" width="18" height="18" alt="8-X" title="Skull">';elseif($n===15)$this->out.='/59.gif" width="18" height="18" alt="8-x" title="Skull">';elseif($n===16)$this->out.='/29.gif" width="18" height="18" alt="8-|" title="Rolling eyes">';else$this->out.='/35.gif" width="24" height="18" alt="8-}" title="Silly">';elseif($n<27)if($n<23)if($n<21)if($n===18)$this->out.='/110.gif" width="36" height="18" alt=":!!" title="Hurry up">';elseif($n===19)$this->out.='/icon_exclaim.gif" width="15" height="17" alt=":!:" title="Exclamation">';else$this->out.='/2.gif" width="18" height="18" alt=":(" title="Sad">';elseif($n===21)$this->out.='/20.gif" width="22" height="18" alt=":((" title="Crying">';else$this->out.='/1.gif" width="18" height="18" alt=":)" title="Happy">';elseif($n===23)$this->out.='/21.gif" width="18" height="18" alt=":))" title="Ha ha">';elseif($n===24)$this->out.='/100.gif" width="31" height="18" alt=":)]" title="On the phone">';elseif($n===25)$this->out.='/115.gif" width="25" height="18" alt=":-!" title="Attention!">';else$this->out.='/65.gif" width="22" height="18" alt=":-&quot;" title="Whistling">';elseif($n<32)if($n<30)if($n===27)$this->out.='/32.gif" width="18" height="18" alt=":-$" title="Shhhh">';elseif($n===28)$this->out.='/2.gif" width="18" height="18" alt=":-(" title="Sad">';else$this->out.='/1.gif" width="18" height="18" alt=":-)" title="Happy">';elseif($n===30)$this->out.='/11.gif" width="18" height="18" alt=":-*" title="Kiss">';else$this->out.='/39.gif" width="18" height="18" alt=":-?" title="Hmm...">';elseif($n===32)$this->out.='/106.gif" width="40" height="18" alt=":-??" title="I dont know">';elseif($n===33)$this->out.='/76.gif" width="36" height="18" alt=":-@" title="Chatterbox">';elseif($n===34)$this->out.='/26.gif" width="24" height="18" alt=":-B" title="Nerd">';else$this->out.='/113.gif" width="39" height="18" alt=":-BD" title="Thumbs up!">';elseif($n<54)if($n<45)if($n<41)if($n<39)if($n===36)$this->out.='/101.gif" width="28" height="18" alt=":-C" title="Call me">';elseif($n===37)$this->out.='/icon_e_biggrin.gif" width="15" height="17" alt=":-D" title="Very Happy">';else$this->out.='/103.gif" width="28" height="18" alt=":-H" title="Wave">';elseif($n===39)$this->out.='/78.gif" width="26" height="18" alt=":-J" title="Ha ha yea right">';else$this->out.='/62.gif" width="18" height="18" alt=":-L" title="Frustrated">';elseif($n===41)$this->out.='/13.gif" width="18" height="18" alt=":-O" title="Surprise">';elseif($n===42)$this->out.='/10.gif" width="18" height="18" alt=":-P" title="Tongue">';elseif($n===43)$this->out.='/112.gif" width="28" height="18" alt=":-Q" title="Thumbs down">';else$this->out.='/17.gif" width="18" height="18" alt=":-S" title="Worried">';elseif($n<50)if($n<48)if($n===45)$this->out.='/42.gif" width="36" height="18" alt=":-SS" title="Nail biting">';elseif($n===46)$this->out.='/104.gif" width="30" height="18" alt=":-T" title="Time out">';else$this->out.='/45.gif" width="23" height="18" alt=":-W" title="Waiting">';elseif($n===48)$this->out.='/7.gif" width="20" height="18" alt=":-\\" title="Confused">';else$this->out.='/26.gif" width="24" height="18" alt=":-b" title="Nerd">';elseif($n===50)$this->out.='/113.gif" width="39" height="18" alt=":-bd" title="Thumbs up!">';elseif($n===51)$this->out.='/101.gif" width="28" height="18" alt=":-c" title="Call me">';elseif($n===52)$this->out.='/103.gif" width="28" height="18" alt=":-h" title="Wave">';else$this->out.='/78.gif" width="26" height="18" alt=":-j" title="Ha ha yea right">';elseif($n<63)if($n<59)if($n<57)if($n===54)$this->out.='/62.gif" width="18" height="18" alt=":-l" title="Frustrated">';elseif($n===55)$this->out.='/13.gif" width="18" height="18" alt=":-o" title="Surprise">';else$this->out.='/10.gif" width="18" height="18" alt=":-p" title="Tongue">';elseif($n===57)$this->out.='/112.gif" width="28" height="18" alt=":-q" title="Thumbs down">';else$this->out.='/17.gif" width="18" height="18" alt=":-s" title="Worried">';elseif($n===59)$this->out.='/42.gif" width="36" height="18" alt=":-ss" title="Nail biting">';elseif($n===60)$this->out.='/104.gif" width="30" height="18" alt=":-t" title="Time out">';elseif($n===61)$this->out.='/45.gif" width="23" height="18" alt=":-w" title="Waiting">';else$this->out.='/icon_question.gif" width="15" height="17" alt=":?:" title="Question">';elseif($n<68)if($n<66)if($n===63)$this->out.='/116.gif" width="20" height="20" alt=":AR!" title="Pirate">';elseif($n===64)$this->out.='/4.gif" width="18" height="18" alt=":D" title="Big Grin">';else$this->out.='/108.gif" width="31" height="18" alt=":O3" title="Puppy dog eyes">';elseif($n===66)$this->out.='/10.gif" width="18" height="18" alt=":P" title="Tongue">';else$this->out.='/8.gif" width="18" height="18" alt=":X" title="Love struck">';elseif($n===68)$this->out.='/61.gif" width="18" height="18" alt=":YMALIEN:" title="Alien">';elseif($n===69)$this->out.='/41.gif" width="18" height="18" alt=":YMAPPLAUSE:" title="Applause">';elseif($n===70)$this->out.='/73.gif" width="18" height="18" alt=":YMBILLY:" title="Billy">';else$this->out.='/70.gif" width="23" height="18" alt=":YMBRINGITON:" title="Bring it on">';elseif($n<108)if($n<90)if($n<81)if($n<77)if($n<75)if($n===72)$this->out.='/105.gif" width="23" height="18" alt=":YMDAYDREAM:" title="Day dreaming">';elseif($n===73)$this->out.='/19.gif" width="18" height="18" alt=":YMDEVIL:" title="Devil">';else$this->out.='/72.gif" width="18" height="18" alt=":YMHIRO:" title="Hiro">';elseif($n===75)$this->out.='/6.gif" width="42" height="18" alt=":YMHUG:" title="Big hug">';else$this->out.='/36.gif" width="38" height="18" alt=":YMPARTY:" title="Party">';elseif($n===77)$this->out.='/67.gif" width="22" height="18" alt=":YMPEACE:" title="Peace sign">';elseif($n===78)$this->out.='/63.gif" width="18" height="18" alt=":YMPRAY:" title="Praying">';elseif($n===79)$this->out.='/31.gif" width="18" height="18" alt=":YMSICK:" title="Sick">';else$this->out.='/46.gif" width="24" height="18" alt=":YMSIGH:" title="Sigh">';elseif($n<86)if($n<84)if($n===81)$this->out.='/15.gif" width="18" height="18" alt=":YMSMUG:" title="Smug">';elseif($n===82)$this->out.='/116.gif" width="20" height="20" alt=":ar!" title="Pirate">';else$this->out.='/icon_arrow.gif" width="15" height="17" alt=":arrow:" title="Arrow">';elseif($n===84)$this->out.='/4.gif" width="18" height="18" alt=":d" title="Big Grin">';else$this->out.='/icon_idea.gif" width="15" height="17" alt=":idea:" title="Idea">';elseif($n===86)$this->out.='/108.gif" width="31" height="18" alt=":o3" title="Puppy dog eyes">';elseif($n===87)$this->out.='/10.gif" width="18" height="18" alt=":p" title="Tongue">';elseif($n===88)$this->out.='/icon_rolleyes.gif" width="15" height="17" alt=":roll:" title="Rolling Eyes">';else$this->out.='/8.gif" width="18" height="18" alt=":x" title="Love struck">';elseif($n<99)if($n<95)if($n<93)if($n===90)$this->out.='/61.gif" width="18" height="18" alt=":ymalien:" title="Alien">';elseif($n===91)$this->out.='/41.gif" width="18" height="18" alt=":ymapplause:" title="Applause">';else$this->out.='/73.gif" width="18" height="18" alt=":ymbilly:" title="Billy">';elseif($n===93)$this->out.='/9.gif" width="18" height="18" alt=":ymblushing:" title="Blushing">';else$this->out.='/70.gif" width="23" height="18" alt=":ymbringiton:" title="Bring it on">';elseif($n===95)$this->out.='/105.gif" width="23" height="18" alt=":ymdaydream:" title="Day dreaming">';elseif($n===96)$this->out.='/19.gif" width="18" height="18" alt=":ymdevil:" title="Devil">';elseif($n===97)$this->out.='/72.gif" width="18" height="18" alt=":ymhiro:" title="Hiro">';else$this->out.='/6.gif" width="42" height="18" alt=":ymhug:" title="Big hug">';elseif($n<104)if($n<102)if($n===99)$this->out.='/36.gif" width="38" height="18" alt=":ymparty:" title="Party">';elseif($n===100)$this->out.='/67.gif" width="22" height="18" alt=":ympeace:" title="Peace sign">';else$this->out.='/63.gif" width="18" height="18" alt=":ympray:" title="Praying">';elseif($n===102)$this->out.='/31.gif" width="18" height="18" alt=":ymsick:" title="Sick">';else$this->out.='/46.gif" width="24" height="18" alt=":ymsigh:" title="Sigh">';elseif($n===104)$this->out.='/15.gif" width="18" height="18" alt=":ymsmug:" title="Smug">';elseif($n===105)$this->out.='/22.gif" width="18" height="18" alt=":|" title="Straight face">';elseif($n===106)$this->out.='/3.gif" width="18" height="18" alt=";)" title="Wink">';else$this->out.='/71.gif" width="18" height="18" alt=";))" title="Hi hi hi">';elseif($n<126)if($n<117)if($n<113)if($n<111)if($n===108)$this->out.='/5.gif" width="18" height="18" alt=";;)" title="Batting eyelashes">';elseif($n===109)$this->out.='/12.gif" width="18" height="18" alt="=((" title="Broken heart">';else$this->out.='/24.gif" width="30" height="18" alt="=))" title="Rolling on the floor">';elseif($n===111)$this->out.='/60.gif" width="20" height="18" alt="=:)" title="Bug">';else$this->out.='/27.gif" width="18" height="18" alt="=;" title="Talk to hand">';elseif($n===113)$this->out.='/38.gif" width="18" height="18" alt="=P~" title="Drooling">';elseif($n===114)$this->out.='/38.gif" width="18" height="18" alt="=p~" title="Drooling">';elseif($n===115)$this->out.='/43.gif" width="18" height="18" alt="@-)" title="Hypnotized">';else$this->out.='/53.gif" width="18" height="18" alt="@};-" title="Rose">';elseif($n<122)if($n<120)if($n===117)$this->out.='/66.gif" width="18" height="18" alt="B-(" title="Beat up">';elseif($n===118)$this->out.='/16.gif" width="18" height="18" alt="B-)" title="Cool">';else$this->out.='/28.gif" width="21" height="18" alt="I-)" title="Sleepy">';elseif($n===120)$this->out.='/25.gif" width="30" height="18" alt="O:-)" title="Angel">';else$this->out.='/14.gif" width="34" height="18" alt="X(" title="Angry">';elseif($n===122)$this->out.='/109.gif" width="25" height="18" alt="X_X" title="I dont wanna see">';elseif($n===123)$this->out.='/33.gif" width="18" height="18" alt="[-(" title="Not talking">';elseif($n===124)$this->out.='/68.gif" width="22" height="18" alt="[-X" title="No no..">';else$this->out.='/68.gif" width="22" height="18" alt="[-x" title="No no..">';elseif($n<135)if($n<131)if($n<129)if($n===126)$this->out.='/69.gif" width="26" height="18" alt="\\:D/" title="Dancing">';elseif($n===127)$this->out.='/69.gif" width="26" height="18" alt="\\:d/" title="Dancing">';else$this->out.='/111.gif" width="32" height="18" alt="\\M/" title="Rock on">';elseif($n===129)$this->out.='/111.gif" width="32" height="18" alt="\\m/" title="Rock on">';else$this->out.='/114.gif" width="40" height="18" alt="^#(^" title="It wasnt me">';elseif($n===131)$this->out.='/77.gif" width="32" height="18" alt="^:)^" title="Praise">';elseif($n===132)$this->out.='/66.gif" width="18" height="18" alt="b-(" title="Beat up">';elseif($n===133)$this->out.='/16.gif" width="18" height="18" alt="b-)" title="Cool">';else$this->out.='/28.gif" width="21" height="18" alt="i-)" title="Sleepy">';elseif($n<139)if($n===135)$this->out.='/74.gif" width="18" height="18" alt="o-+" title="April">';elseif($n===136)$this->out.='/25.gif" width="30" height="18" alt="o:-)" title="Angel">';elseif($n===137)$this->out.='/14.gif" width="34" height="18" alt="x(" title="Angry">';else$this->out.='/109.gif" width="25" height="18" alt="x_x" title="I dont wanna see">';elseif($n===139)$this->out.='/57.gif" width="18" height="18" alt="~O)" title="Coffee">';elseif($n===140)$this->out.='/102.gif" width="44" height="18" alt="~X(" title="at wits\' end">';elseif($n===141)$this->out.='/57.gif" width="18" height="18" alt="~o)" title="Coffee">';else$this->out.='/102.gif" width="44" height="18" alt="~x(" title="at wits\' end">';}else$this->out.=htmlspecialchars($node->textContent,0);elseif($tb<8)if($tb===5){$this->out.='<a href="mailto:'.htmlspecialchars($node->getAttribute('email'),2);if($node->hasAttribute('subject')||$node->hasAttribute('body')){$this->out.='?';if($node->hasAttribute('subject'))$this->out.='subject='.htmlspecialchars($node->getAttribute('subject'),2);if($node->hasAttribute('body')){if($node->hasAttribute('subject'))$this->out.='&amp;';$this->out.='body='.htmlspecialchars($node->getAttribute('body'),2);}}$this->out.='">';$this->at($node);$this->out.='</a>';}elseif($tb===6)if(!empty($this->params['S_VIEWSMILIES']))$this->out.='<img alt="'.htmlspecialchars($node->textContent,2).'" class="emoji smilies" draggable="false" src="//cdn.jsdelivr.net/emojione/assets/svg/'.htmlspecialchars($node->getAttribute('seq'),2).'.svg">';else$this->out.=htmlspecialchars($node->textContent,0);elseif(!empty($this->params['S_VIEWFLASH']))$this->out.='<object classid="clsid:D27CDB6E-AE6D-11CF-96B8-444553540000" codebase="http://active.macromedia.com/flash2/cabs/swflash.cab#version=5,0,0,0" width="'.htmlspecialchars($node->getAttribute('width'),2).'" height="'.htmlspecialchars($node->getAttribute('height'),2).'"><param name="movie" value="'.htmlspecialchars($node->getAttribute('url'),2).'"><param name="play" value="false"><param name="loop" value="false"><param name="quality" value="high"><param name="allowScriptAccess" value="never"><param name="allowNetworking" value="internal"><embed src="'.htmlspecialchars($node->getAttribute('url'),2).'" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash" width="'.htmlspecialchars($node->getAttribute('width'),2).'" height="'.htmlspecialchars($node->getAttribute('height'),2).'" play="false" loop="false" quality="high" allowscriptaccess="never" allownetworking="internal"></object>';else$this->at($node);elseif($tb===8)if($this->params['STYLE_ID']==2){$this->out.='<em>';$this->at($node);$this->out.='</em>';}else{$this->out.='<span style="font-style: italic">';$this->at($node);$this->out.='</span>';}elseif(!empty($this->params['S_VIEWIMG']))$this->out.='<img src="'.htmlspecialchars($node->getAttribute('src'),2).'" class="postimage" alt="'.htmlspecialchars($this->params['L_IMAGE'],2).'">';else$this->at($node);elseif($tb<15)if($tb<13)if($tb===10){$this->out.='<li>';$this->at($node);$this->out.='</li>';}elseif($tb===11)$this->out.=htmlspecialchars($node->getAttribute('text'),0);elseif(!$node->hasAttribute('type')){$this->out.='<ul>';$this->at($node);$this->out.='</ul>';}elseif((strpos('upperlowerdecim',mb_substr($node->getAttribute('type'),0,5,'utf-8'))!==false)){$this->out.='<ol style="list-style-type: '.htmlspecialchars($node->getAttribute('type'),2).'">';$this->at($node);$this->out.='</ol>';}else{$this->out.='<ul style="list-style-type: '.htmlspecialchars($node->getAttribute('type'),2).'">';$this->at($node);$this->out.='</ul>';}elseif($tb===13){$this->out.='<blockquote';if(!$node->hasAttribute('author'))$this->out.=' class="uncited"';$this->out.='><div>';if($node->hasAttribute('author')){$this->out.='<cite>';if($node->hasAttribute('url'))$this->out.='<a href="'.htmlspecialchars($node->getAttribute('url'),2).'" class="postlink">'.htmlspecialchars($node->getAttribute('author'),0).'</a>';elseif($node->hasAttribute('profile_url'))$this->out.='<a href="'.htmlspecialchars($node->getAttribute('profile_url'),2).'">'.htmlspecialchars($node->getAttribute('author'),0).'</a>';else$this->out.=htmlspecialchars($node->getAttribute('author'),0);$this->out.=' '.htmlspecialchars($this->params['L_WROTE'].$this->params['L_COLON'],0);if($node->hasAttribute('post_url'))$this->out.=' <a href="'.htmlspecialchars($node->getAttribute('post_url'),2).'" data-post-id="'.htmlspecialchars($node->getAttribute('post_id'),2).'" onclick="if(document.getElementById(hash.substr(1)))href=hash">↑</a>';if($node->hasAttribute('date'))$this->out.='<div class="responsive-hide">'.htmlspecialchars($node->getAttribute('date'),0).'</div>';$this->out.='</cite>';}$this->at($node);$this->out.='</div></blockquote>';}else{$this->out.='<span style="font-size: '.htmlspecialchars($node->getAttribute('size'),2).'%; line-height: normal">';$this->at($node);$this->out.='</span>';}elseif($tb<18)if($tb===15){$this->out.='<span style="text-decoration: underline">';$this->at($node);$this->out.='</span>';}elseif($tb===16){$this->out.='<a href="'.htmlspecialchars($node->getAttribute('url'),2).'" class="postlink">';$this->at($node);$this->out.='</a>';}else$this->out.='<br>';elseif($tb===18);else{$this->out.='<p>';$this->at($node);$this->out.='</p>';}
				}
	}
	private static $static=array('/CODE'=>'</code></pre></div>','/COLOR'=>'</span>','/EMAIL'=>'</a>','/LI'=>'</li>','/QUOTE'=>'</div></blockquote>','/SIZE'=>'</span>','/U'=>'</span>','/URL'=>'</a>','LI'=>'<li>','U'=>'<span style="text-decoration: underline">');
	private static $dynamic=array('COLOR'=>array('(^[^ ]+(?> (?!color=)[^=]+="[^"]*")*(?> color="([^"]*)")?.*)s','<span style="color: $1">'),'SIZE'=>array('(^[^ ]+(?> (?!size=)[^=]+="[^"]*")*(?> size="([^"]*)")?.*)s','<span style="font-size: $1%; line-height: normal">'),'URL'=>array('(^[^ ]+(?> (?!url=)[^=]+="[^"]*")*(?> url="([^"]*)")?.*)s','<a href="$1" class="postlink">'));
	private static $attributes;
	private static $quickBranches=array('/B'=>0,'/I'=>1,'/LIST'=>2,'ATTACHMENT'=>3,'B'=>4,'CODE'=>5,'E'=>6,'EMAIL'=>7,'EMOJI'=>8,'I'=>9,'LINK_TEXT'=>10,'LIST'=>11,'QUOTE'=>12);
	public $quickRenderingTest='(<(?=[FI])(?>FLASH|IMG)[ />])';

	protected function renderQuick($xml)
	{
		$xml = $this->decodeSMP($xml);
		self::$attributes = array();
		$html = preg_replace_callback(
			'(<(?:(?!/)((?:ATTACHMENT|E(?>MOJI)?|LINK_TEXT))(?: [^>]*)?>.*?</\\1|(/?(?!br/|p>)[^ />]+)[^>]*?(/)?)>)s',
			array($this, 'quick'),
			preg_replace(
				'(<[eis]>[^<]*</[eis]>)',
				'',
				substr($xml, 1 + strpos($xml, '>'), -4)
			)
		);

		return str_replace('<br/>', '<br>', $html);
	}

	protected function quick($m)
	{
		if (isset($m[2]))
		{
			$id = $m[2];

			if (isset($m[3]))
			{
				unset($m[3]);

				$m[0] = substr($m[0], 0, -2) . '>';
				$html = $this->quick($m);

				$m[0] = '</' . $id . '>';
				$m[2] = '/' . $id;
				$html .= $this->quick($m);

				return $html;
			}
		}
		else
		{
			$id = $m[1];

			$lpos = 1 + strpos($m[0], '>');
			$rpos = strrpos($m[0], '<');
			$textContent = substr($m[0], $lpos, $rpos - $lpos);

			if (strpos($textContent, '<') !== false)
				throw new \RuntimeException;

			$textContent = htmlspecialchars_decode($textContent);
		}

		if (isset(self::$static[$id]))
			return self::$static[$id];

		if (isset(self::$dynamic[$id]))
		{
			list($match, $replace) = self::$dynamic[$id];
			return preg_replace($match, $replace, $m[0], 1);
		}

		if (!isset(self::$quickBranches[$id]))
		{
			if ($id[0] === '!' || $id[0] === '?' || preg_match('(^/?(?>FLASH|IMG)$)', $id))
				throw new \RuntimeException;
			return '';
		}

		$attributes = array();
		if (strpos($m[0], '="') !== false)
		{
			preg_match_all('(([^ =]++)="([^"]*))S', substr($m[0], 0, strpos($m[0], '>')), $matches);
			foreach ($matches[1] as $i => $attrName)
				$attributes[$attrName] = $matches[2][$i];
		}

		$qb = self::$quickBranches[$id];
		if($qb<7)if($qb<4)if($qb===0){$html='';if($this->params['STYLE_ID']==2)$html.='</strong>';else$html.='</span>';}elseif($qb===1){$html='';if($this->params['STYLE_ID']==2)$html.='</em>';else$html.='</span>';}elseif($qb===2){$attributes=array_pop(self::$attributes);$html='';if(!isset($attributes['type']))$html.='</ul>';elseif((strpos('upperlowerdecim',mb_substr(htmlspecialchars_decode($attributes['type']),0,5,'utf-8'))!==false))$html.='</ol>';else$html.='</ul>';}else{$attributes+=array('index'=>null,'filename'=>null);$html='<div class="inline-attachment"><!-- ia'.str_replace('&quot;','"',$attributes['index']).' -->'.str_replace('&quot;','"',$attributes['filename']).'<!-- ia'.str_replace('&quot;','"',$attributes['index']).' --></div>';}elseif($qb===4){$html='';if($this->params['STYLE_ID']==2)$html.='<strong>';else$html.='<span style="font-weight: bold">';}elseif($qb===5)$html='<div class="codebox"><p>'.htmlspecialchars($this->params['L_CODE'].$this->params['L_COLON'],0).' <a href="#" onclick="selectCode(this); return false;">'.htmlspecialchars($this->params['L_SELECT_ALL_CODE'],0).'</a></p><pre><code>';else{$html='';if(empty($this->params['S_VIEWSMILIES']))$html.=htmlspecialchars($textContent,0);elseif(isset(self::$bt57355554[$textContent])){$n=self::$bt57355554[$textContent];$html.='<img class="smilies" src="'.htmlspecialchars($this->params['T_SMILIES_PATH'],2);if($n<72)if($n<36)if($n<18)if($n<9)if($n<5)if($n<3)if($n===0)$html.='/40.gif" width="24" height="18" alt="#-O" title="D oh">';elseif($n===1)$html.='/40.gif" width="24" height="18" alt="#-o" title="D oh">';else$html.='/18.gif" width="34" height="18" alt="#:-S" title="Whew!">';elseif($n===3)$html.='/18.gif" width="34" height="18" alt="#:-s" title="Whew!">';else$html.='/64.gif" width="18" height="18" alt="$-)" title="Money eyes">';elseif($n===5)$html.='/54.gif" width="18" height="18" alt="%%-" title="Clover">';elseif($n===6)$html.='/107.gif" width="52" height="18" alt="%-(" title="Not listening">';elseif($n===7)$html.='/75.gif" width="18" height="18" alt="(%)" title="Yin Yang">';else$html.='/79.gif" width="18" height="18" alt="(*)" title="Star">';elseif($n<14)if($n<12)if($n===9)$html.='/37.gif" width="18" height="18" alt="(-|" title="Yawn">';elseif($n===10)$html.='/56.gif" width="17" height="18" alt="(~~)" title="Pumpkin">';else$html.='/55.gif" width="25" height="18" alt="**==" title="US Flag">';elseif($n===12)$html.='/58.gif" width="30" height="18" alt="*-:)" title="Idea">';else$html.='/23.gif" width="18" height="18" alt="/:)" title="Raised eyebrows">';elseif($n===14)$html.='/59.gif" width="18" height="18" alt="8-X" title="Skull">';elseif($n===15)$html.='/59.gif" width="18" height="18" alt="8-x" title="Skull">';elseif($n===16)$html.='/29.gif" width="18" height="18" alt="8-|" title="Rolling eyes">';else$html.='/35.gif" width="24" height="18" alt="8-}" title="Silly">';elseif($n<27)if($n<23)if($n<21)if($n===18)$html.='/110.gif" width="36" height="18" alt=":!!" title="Hurry up">';elseif($n===19)$html.='/icon_exclaim.gif" width="15" height="17" alt=":!:" title="Exclamation">';else$html.='/2.gif" width="18" height="18" alt=":(" title="Sad">';elseif($n===21)$html.='/20.gif" width="22" height="18" alt=":((" title="Crying">';else$html.='/1.gif" width="18" height="18" alt=":)" title="Happy">';elseif($n===23)$html.='/21.gif" width="18" height="18" alt=":))" title="Ha ha">';elseif($n===24)$html.='/100.gif" width="31" height="18" alt=":)]" title="On the phone">';elseif($n===25)$html.='/115.gif" width="25" height="18" alt=":-!" title="Attention!">';else$html.='/65.gif" width="22" height="18" alt=":-&quot;" title="Whistling">';elseif($n<32)if($n<30)if($n===27)$html.='/32.gif" width="18" height="18" alt=":-$" title="Shhhh">';elseif($n===28)$html.='/2.gif" width="18" height="18" alt=":-(" title="Sad">';else$html.='/1.gif" width="18" height="18" alt=":-)" title="Happy">';elseif($n===30)$html.='/11.gif" width="18" height="18" alt=":-*" title="Kiss">';else$html.='/39.gif" width="18" height="18" alt=":-?" title="Hmm...">';elseif($n===32)$html.='/106.gif" width="40" height="18" alt=":-??" title="I dont know">';elseif($n===33)$html.='/76.gif" width="36" height="18" alt=":-@" title="Chatterbox">';elseif($n===34)$html.='/26.gif" width="24" height="18" alt=":-B" title="Nerd">';else$html.='/113.gif" width="39" height="18" alt=":-BD" title="Thumbs up!">';elseif($n<54)if($n<45)if($n<41)if($n<39)if($n===36)$html.='/101.gif" width="28" height="18" alt=":-C" title="Call me">';elseif($n===37)$html.='/icon_e_biggrin.gif" width="15" height="17" alt=":-D" title="Very Happy">';else$html.='/103.gif" width="28" height="18" alt=":-H" title="Wave">';elseif($n===39)$html.='/78.gif" width="26" height="18" alt=":-J" title="Ha ha yea right">';else$html.='/62.gif" width="18" height="18" alt=":-L" title="Frustrated">';elseif($n===41)$html.='/13.gif" width="18" height="18" alt=":-O" title="Surprise">';elseif($n===42)$html.='/10.gif" width="18" height="18" alt=":-P" title="Tongue">';elseif($n===43)$html.='/112.gif" width="28" height="18" alt=":-Q" title="Thumbs down">';else$html.='/17.gif" width="18" height="18" alt=":-S" title="Worried">';elseif($n<50)if($n<48)if($n===45)$html.='/42.gif" width="36" height="18" alt=":-SS" title="Nail biting">';elseif($n===46)$html.='/104.gif" width="30" height="18" alt=":-T" title="Time out">';else$html.='/45.gif" width="23" height="18" alt=":-W" title="Waiting">';elseif($n===48)$html.='/7.gif" width="20" height="18" alt=":-\\" title="Confused">';else$html.='/26.gif" width="24" height="18" alt=":-b" title="Nerd">';elseif($n===50)$html.='/113.gif" width="39" height="18" alt=":-bd" title="Thumbs up!">';elseif($n===51)$html.='/101.gif" width="28" height="18" alt=":-c" title="Call me">';elseif($n===52)$html.='/103.gif" width="28" height="18" alt=":-h" title="Wave">';else$html.='/78.gif" width="26" height="18" alt=":-j" title="Ha ha yea right">';elseif($n<63)if($n<59)if($n<57)if($n===54)$html.='/62.gif" width="18" height="18" alt=":-l" title="Frustrated">';elseif($n===55)$html.='/13.gif" width="18" height="18" alt=":-o" title="Surprise">';else$html.='/10.gif" width="18" height="18" alt=":-p" title="Tongue">';elseif($n===57)$html.='/112.gif" width="28" height="18" alt=":-q" title="Thumbs down">';else$html.='/17.gif" width="18" height="18" alt=":-s" title="Worried">';elseif($n===59)$html.='/42.gif" width="36" height="18" alt=":-ss" title="Nail biting">';elseif($n===60)$html.='/104.gif" width="30" height="18" alt=":-t" title="Time out">';elseif($n===61)$html.='/45.gif" width="23" height="18" alt=":-w" title="Waiting">';else$html.='/icon_question.gif" width="15" height="17" alt=":?:" title="Question">';elseif($n<68)if($n<66)if($n===63)$html.='/116.gif" width="20" height="20" alt=":AR!" title="Pirate">';elseif($n===64)$html.='/4.gif" width="18" height="18" alt=":D" title="Big Grin">';else$html.='/108.gif" width="31" height="18" alt=":O3" title="Puppy dog eyes">';elseif($n===66)$html.='/10.gif" width="18" height="18" alt=":P" title="Tongue">';else$html.='/8.gif" width="18" height="18" alt=":X" title="Love struck">';elseif($n===68)$html.='/61.gif" width="18" height="18" alt=":YMALIEN:" title="Alien">';elseif($n===69)$html.='/41.gif" width="18" height="18" alt=":YMAPPLAUSE:" title="Applause">';elseif($n===70)$html.='/73.gif" width="18" height="18" alt=":YMBILLY:" title="Billy">';else$html.='/70.gif" width="23" height="18" alt=":YMBRINGITON:" title="Bring it on">';elseif($n<108)if($n<90)if($n<81)if($n<77)if($n<75)if($n===72)$html.='/105.gif" width="23" height="18" alt=":YMDAYDREAM:" title="Day dreaming">';elseif($n===73)$html.='/19.gif" width="18" height="18" alt=":YMDEVIL:" title="Devil">';else$html.='/72.gif" width="18" height="18" alt=":YMHIRO:" title="Hiro">';elseif($n===75)$html.='/6.gif" width="42" height="18" alt=":YMHUG:" title="Big hug">';else$html.='/36.gif" width="38" height="18" alt=":YMPARTY:" title="Party">';elseif($n===77)$html.='/67.gif" width="22" height="18" alt=":YMPEACE:" title="Peace sign">';elseif($n===78)$html.='/63.gif" width="18" height="18" alt=":YMPRAY:" title="Praying">';elseif($n===79)$html.='/31.gif" width="18" height="18" alt=":YMSICK:" title="Sick">';else$html.='/46.gif" width="24" height="18" alt=":YMSIGH:" title="Sigh">';elseif($n<86)if($n<84)if($n===81)$html.='/15.gif" width="18" height="18" alt=":YMSMUG:" title="Smug">';elseif($n===82)$html.='/116.gif" width="20" height="20" alt=":ar!" title="Pirate">';else$html.='/icon_arrow.gif" width="15" height="17" alt=":arrow:" title="Arrow">';elseif($n===84)$html.='/4.gif" width="18" height="18" alt=":d" title="Big Grin">';else$html.='/icon_idea.gif" width="15" height="17" alt=":idea:" title="Idea">';elseif($n===86)$html.='/108.gif" width="31" height="18" alt=":o3" title="Puppy dog eyes">';elseif($n===87)$html.='/10.gif" width="18" height="18" alt=":p" title="Tongue">';elseif($n===88)$html.='/icon_rolleyes.gif" width="15" height="17" alt=":roll:" title="Rolling Eyes">';else$html.='/8.gif" width="18" height="18" alt=":x" title="Love struck">';elseif($n<99)if($n<95)if($n<93)if($n===90)$html.='/61.gif" width="18" height="18" alt=":ymalien:" title="Alien">';elseif($n===91)$html.='/41.gif" width="18" height="18" alt=":ymapplause:" title="Applause">';else$html.='/73.gif" width="18" height="18" alt=":ymbilly:" title="Billy">';elseif($n===93)$html.='/9.gif" width="18" height="18" alt=":ymblushing:" title="Blushing">';else$html.='/70.gif" width="23" height="18" alt=":ymbringiton:" title="Bring it on">';elseif($n===95)$html.='/105.gif" width="23" height="18" alt=":ymdaydream:" title="Day dreaming">';elseif($n===96)$html.='/19.gif" width="18" height="18" alt=":ymdevil:" title="Devil">';elseif($n===97)$html.='/72.gif" width="18" height="18" alt=":ymhiro:" title="Hiro">';else$html.='/6.gif" width="42" height="18" alt=":ymhug:" title="Big hug">';elseif($n<104)if($n<102)if($n===99)$html.='/36.gif" width="38" height="18" alt=":ymparty:" title="Party">';elseif($n===100)$html.='/67.gif" width="22" height="18" alt=":ympeace:" title="Peace sign">';else$html.='/63.gif" width="18" height="18" alt=":ympray:" title="Praying">';elseif($n===102)$html.='/31.gif" width="18" height="18" alt=":ymsick:" title="Sick">';else$html.='/46.gif" width="24" height="18" alt=":ymsigh:" title="Sigh">';elseif($n===104)$html.='/15.gif" width="18" height="18" alt=":ymsmug:" title="Smug">';elseif($n===105)$html.='/22.gif" width="18" height="18" alt=":|" title="Straight face">';elseif($n===106)$html.='/3.gif" width="18" height="18" alt=";)" title="Wink">';else$html.='/71.gif" width="18" height="18" alt=";))" title="Hi hi hi">';elseif($n<126)if($n<117)if($n<113)if($n<111)if($n===108)$html.='/5.gif" width="18" height="18" alt=";;)" title="Batting eyelashes">';elseif($n===109)$html.='/12.gif" width="18" height="18" alt="=((" title="Broken heart">';else$html.='/24.gif" width="30" height="18" alt="=))" title="Rolling on the floor">';elseif($n===111)$html.='/60.gif" width="20" height="18" alt="=:)" title="Bug">';else$html.='/27.gif" width="18" height="18" alt="=;" title="Talk to hand">';elseif($n===113)$html.='/38.gif" width="18" height="18" alt="=P~" title="Drooling">';elseif($n===114)$html.='/38.gif" width="18" height="18" alt="=p~" title="Drooling">';elseif($n===115)$html.='/43.gif" width="18" height="18" alt="@-)" title="Hypnotized">';else$html.='/53.gif" width="18" height="18" alt="@};-" title="Rose">';elseif($n<122)if($n<120)if($n===117)$html.='/66.gif" width="18" height="18" alt="B-(" title="Beat up">';elseif($n===118)$html.='/16.gif" width="18" height="18" alt="B-)" title="Cool">';else$html.='/28.gif" width="21" height="18" alt="I-)" title="Sleepy">';elseif($n===120)$html.='/25.gif" width="30" height="18" alt="O:-)" title="Angel">';else$html.='/14.gif" width="34" height="18" alt="X(" title="Angry">';elseif($n===122)$html.='/109.gif" width="25" height="18" alt="X_X" title="I dont wanna see">';elseif($n===123)$html.='/33.gif" width="18" height="18" alt="[-(" title="Not talking">';elseif($n===124)$html.='/68.gif" width="22" height="18" alt="[-X" title="No no..">';else$html.='/68.gif" width="22" height="18" alt="[-x" title="No no..">';elseif($n<135)if($n<131)if($n<129)if($n===126)$html.='/69.gif" width="26" height="18" alt="\\:D/" title="Dancing">';elseif($n===127)$html.='/69.gif" width="26" height="18" alt="\\:d/" title="Dancing">';else$html.='/111.gif" width="32" height="18" alt="\\M/" title="Rock on">';elseif($n===129)$html.='/111.gif" width="32" height="18" alt="\\m/" title="Rock on">';else$html.='/114.gif" width="40" height="18" alt="^#(^" title="It wasnt me">';elseif($n===131)$html.='/77.gif" width="32" height="18" alt="^:)^" title="Praise">';elseif($n===132)$html.='/66.gif" width="18" height="18" alt="b-(" title="Beat up">';elseif($n===133)$html.='/16.gif" width="18" height="18" alt="b-)" title="Cool">';else$html.='/28.gif" width="21" height="18" alt="i-)" title="Sleepy">';elseif($n<139)if($n===135)$html.='/74.gif" width="18" height="18" alt="o-+" title="April">';elseif($n===136)$html.='/25.gif" width="30" height="18" alt="o:-)" title="Angel">';elseif($n===137)$html.='/14.gif" width="34" height="18" alt="x(" title="Angry">';else$html.='/109.gif" width="25" height="18" alt="x_x" title="I dont wanna see">';elseif($n===139)$html.='/57.gif" width="18" height="18" alt="~O)" title="Coffee">';elseif($n===140)$html.='/102.gif" width="44" height="18" alt="~X(" title="at wits\' end">';elseif($n===141)$html.='/57.gif" width="18" height="18" alt="~o)" title="Coffee">';else$html.='/102.gif" width="44" height="18" alt="~x(" title="at wits\' end">';}else$html.=htmlspecialchars($textContent,0);}elseif($qb<10)if($qb===7){$attributes+=array('email'=>null,'body'=>null);$html='<a href="mailto:'.$attributes['email'];if(isset($attributes['subject'])||isset($attributes['body'])){$html.='?';if(isset($attributes['subject']))$html.='subject='.$attributes['subject'];if(isset($attributes['body'])){if(isset($attributes['subject']))$html.='&amp;';$html.='body='.$attributes['body'];}}$html.='">';}elseif($qb===8){$attributes+=array('seq'=>null);$html='';if(!empty($this->params['S_VIEWSMILIES']))$html.='<img alt="'.htmlspecialchars($textContent,2).'" class="emoji smilies" draggable="false" src="//cdn.jsdelivr.net/emojione/assets/svg/'.$attributes['seq'].'.svg">';else$html.=htmlspecialchars($textContent,0);}else{$html='';if($this->params['STYLE_ID']==2)$html.='<em>';else$html.='<span style="font-style: italic">';}elseif($qb===10){$attributes+=array('text'=>null);$html=str_replace('&quot;','"',$attributes['text']);}elseif($qb===11){$attributes+=array('type'=>null);$html='';if(!isset($attributes['type']))$html.='<ul>';elseif((strpos('upperlowerdecim',mb_substr(htmlspecialchars_decode($attributes['type']),0,5,'utf-8'))!==false))$html.='<ol style="list-style-type: '.$attributes['type'].'">';else$html.='<ul style="list-style-type: '.$attributes['type'].'">';self::$attributes[]=$attributes;}else{$attributes+=array('url'=>null,'author'=>null,'post_id'=>null);$html='<blockquote';if(!isset($attributes['author']))$html.=' class="uncited"';$html.='><div>';if(isset($attributes['author'])){$html.='<cite>';if(isset($attributes['url']))$html.='<a href="'.$attributes['url'].'" class="postlink">'.str_replace('&quot;','"',$attributes['author']).'</a>';elseif(isset($attributes['profile_url']))$html.='<a href="'.$attributes['profile_url'].'">'.str_replace('&quot;','"',$attributes['author']).'</a>';else$html.=str_replace('&quot;','"',$attributes['author']);$html.=' '.htmlspecialchars($this->params['L_WROTE'].$this->params['L_COLON'],0);if(isset($attributes['post_url']))$html.=' <a href="'.$attributes['post_url'].'" data-post-id="'.$attributes['post_id'].'" onclick="if(document.getElementById(hash.substr(1)))href=hash">↑</a>';if(isset($attributes['date']))$html.='<div class="responsive-hide">'.str_replace('&quot;','"',$attributes['date']).'</div>';$html.='</cite>';}}

		return $html;
	}
}